import os
import sys
import subprocess


from user_param import *


def OSinfo(runthis):
	red = lambda text: '\033[0;31m' + text + '\033[0m'
	osstdout = subprocess.Popen(runthis, shell=True, stdin=subprocess.PIPE, stdout=subprocess.PIPE, stderr=subprocess.STDOUT, close_fds=True)
	theInfo = osstdout.communicate()[0].strip()
	if osstdout.returncode!=0:
		print(red(runthis+" FAILED"))
		print >> sys.stderr, osstdout.returncode
		sys.exit()
	# else:
		# print(runthis+" OK")


def main():

	black = lambda text: '\033[0;30m' + text + '\033[0m'
	red = lambda text: '\033[0;31m' + text + '\033[0m'
	green = lambda text: '\033[0;32m' + text + '\033[0m'
	yellow = lambda text: '\033[0;33m' + text + '\033[0m'
	blue = lambda text: '\033[0;34m' + text + '\033[0m'
	magenta = lambda text: '\033[0;35m' + text + '\033[0m'
	cyan = lambda text: '\033[0;36m' + text + '\033[0m'
	lgray = lambda text: '\033[0;37m' + text + '\033[0m'
	dgray = lambda text: '\033[1;30m' + text + '\033[0m'
	lred = lambda text: '\033[1;32m' + text + '\033[0m'
	lgreen = lambda text: '\033[1;32m' + text + '\033[0m'
	lyellow = lambda text: '\033[1;33m' + text + '\033[0m'
	lblue = lambda text: '\033[1;34m' + text + '\033[0m'
	lpurple = lambda text: '\033[1;35m' + text + '\033[0m'
	lcyan = lambda text: '\033[1;36m' + text + '\033[0m'
	white = lambda text: '\033[1;37m' + text + '\033[0m'
	
	configNamePattern=[0]*7

	f=open("user_param.py", "r")
	for line in f:
		line = line.strip()
		if line.startswith("UsingServer2"):
			configNamePattern[0] = '_UsingSrv2=' + UsingServer2
		elif line.startswith("RatioServer2"):
			configNamePattern[1] = '_RatioSrv2=' + repr(RatioServer2)
		elif line.startswith("NumberPoolsServer2"):
			configNamePattern[2] = '_NbPoolsSrv2=' + repr(NumberPoolsServer2)
		elif line.startswith("NumberClients"):
			configNamePattern[3] = '_NbClients=' + repr(NumberClients)
		elif line.startswith("NumberServers"):
			configNamePattern[4] = '_NbServers=' + repr(NumberServers)
		elif line.startswith("Duration"):
			configNamePattern[5] = '_Duration=' + Duration
		elif line.startswith("ATMdomain"):
			configNamePattern[5] = '_ATMdomain=' + ATMdomain
	f.close()
		
	

	configName = "config"
	defaultConfig = True

	for i in range(len(configNamePattern)):
		if configNamePattern[i] != 0:
			configName = configName + configNamePattern[i]
			defaultConfig = False

	if defaultConfig:
		configName = "config_default"

	check_result=False


	if not os.path.exists(configName):
		os.mkdir(configName)
		print blue("\n    ****************************************************************")
		print blue("    * Directory " + repr(configName) + " Created ")
		print blue("    * Copy results to \'not_validated_reference\' folder")
		print blue("    ****************************************************************\n")

		OSinfo("mkdir "+configName+'/setup')
		OSinfo('mkdir '+configName+'/tmp_reference')
		OSinfo('mkdir '+configName+'/xios_output')
		
		OSinfo('mv param.def '+configName+'/setup/')
		OSinfo('mv all_param.def '+configName+'/setup/')
		OSinfo('mv user_param.py '+configName+'/setup/')
		OSinfo('mv iodef.xml '+configName+'/setup/')
		OSinfo('cp context_atm.xml '+configName+'/setup/')
		OSinfo('cp context_grid_dynamico.xml '+configName+'/setup/')
		OSinfo('cp dynamico_grid.nc '+configName+'/setup/')
		OSinfo('mv xios_*.out '+configName+'/xios_output/')
		OSinfo('mv xios_*.err '+configName+'/xios_output/')
		

		f=open("checkfile.def", "r")
		h=open("report.txt", "a+")
		l=open("report.html", "a+")
		h.write("Config : "+configName+"\n")		
		l.write("<p>Config : "+configName+"</p>")	
		endloop=False
		for line in f:
			line=line.strip()
			line=line.rstrip()

			if line.startswith("all"):
				allfiles = os.listdir(os.getcwd())
				for thisfile in allfiles:
					if thisfile.endswith(".nc") and thisfile!="dynamico_grid.nc":
						cmd = 'mv '+thisfile + ' '+configName+'/tmp_reference/'
						OSinfo(cmd)	
				
				h.write("test for "+lpurple("all NC files")+"     \t"+yellow('INITIALIZED')+"\n")		
				l.write("<p>test for <font color=\"purple\">"+"all NC files"+"</font> &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; <font color=\"darkorange\">INITIALIZED</font></p>")
				print yellow("\n        ****************************************")
				print yellow("        ** "+"all NC files"+" is stored as temporal reference !!! **")
				print yellow("\n        ****************************************")

				break

			if not line.startswith("#") and len(line) != 0:
				cmd = 'mv '+line + ' '+configName+'/tmp_reference/'
				OSinfo(cmd)

				h.write("test for "+lpurple(line)+"     \t"+yellow('INITIALIZED')+"\n")		
				l.write("<p>test for <font color=\"purple\">"+line+"</font> &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; <font color=\"darkorange\">INITIALIZED</font></p>")
				print yellow("\n        ****************************************")
				print yellow("        ** "+line+" is stored as temporal reference !!! **")
				print yellow("\n        ****************************************")
				
		f.close()
		h.write("\n")
		l.write("<br>")
		h.close()


	else:    
		print blue("\n    ********************************************************")
		print blue("    * Directory " + repr(configName) + " already exists")
		print blue("    * Start comparing results with references")
		print blue("    ********************************************************\n")

		tmp_ref = os.path.isdir(configName+'/tmp_reference')
		ref = os.path.isdir(configName+'/reference') and not tmp_ref

		if ref:
			print blue("\n    =====================================")
			print blue("    | Comparing results with references |")
			print blue("    =====================================\n")
			path = configName+'/reference/'
		elif tmp_ref:
			print blue("\n    ===================================================")
			print blue("    | Comparing results with NON-Validated references |")
			print blue("    ===================================================\n")
			path = configName+'/tmp_reference/'
		
		f=open("checkfile.def", "r")
		h=open("report.txt", "a+")
		l=open("report.html", "a+")


		h.write("Config : "+configName+"\n")	
		l.write("<p>Config : "+configName+"</p>")	
		for line in f:

			line=line.strip()
			line=line.rstrip()
			
			if line.startswith("all") :
				for thisfile in os.listdir(path):
					if thisfile.endswith(".nc"):
						cmd = 'cdo -W diffn '+ thisfile +' '+ path + thisfile + ' | tail -1 > diff.txt'
						
						OSinfo(cmd)
						
						if os.stat("diff.txt").st_size==0:
							h.write("test for "+lpurple(thisfile)+"     \t"+green('PASSED')+"\n")		
							l.write("<p>test for <font color=\"purple\">"+thisfile+"</font> &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; <font color=\"green\">PASSED</font></p>")		
							print green("\n        ****************************************")
							print green("        ** "+thisfile+" is valid !!! **")
							print green("\n        ****************************************")

						else:	
							g=open("diff.txt", "r")
							for gline in g:
								if gline.strip().startswith("0") or ":" in gline :
									h.write("test for "+lpurple(thisfile)+"      \t"+green('PASSED')+"\n")		
									l.write("<p>test for <font color=\"purple\">"+thisfile+"</font> &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; <font color=\"green\">PASSED</font></p>")		
									print green("\n        ****************************************")
									print green("        ** "+thisfile+" is valid !!! **")
									print green("\n        ****************************************")
								else:
									h.write("test for "+lpurple(thisfile)+"     \t"+red('FAILED')+"\n")		
									l.write("<p>test for <font color=\"purple\">"+thisfile+"</font> &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; <font color=\"red\">FAILED</font></p>")		
									print red("\n        **************************************************")
									print red("        ** "+thisfile+" is NOT valid. Please debugging.. **")
									print red("\n        **************************************************")
							g.close()
				break


			elif not line.startswith("#") and len(line) != 0:
				cmd = 'cdo -W diffn '+ line +' '+ path + line + ' | tail -1 > diff.txt'
				
				OSinfo(cmd)

				if os.stat("diff.txt").st_size==0:
					h.write("test for "+lpurple(line)+"     \t"+green('PASSED')+"\n")		
					l.write("<p>test for <font color=\"purple\">"+line+"</font> &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; <font color=\"green\">PASSED</font></p>")		
					print green("\n        ****************************************")
					print green("        ** "+line+" is valid !!! **")
					print green("\n        ****************************************")

				else:	
					g=open("diff.txt", "r")
					for gline in g:
						if gline.strip().startswith("0") or ":" in gline :
							h.write("test for "+lpurple(line)+"      \t"+green('PASSED')+"\n")		
							l.write("<p>test for <font color=\"purple\">"+line+"</font> &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; <font color=\"green\">PASSED</font></p>")		
							print green("\n        ****************************************")
							print green("        ** "+line+" is valid !!! **")
							print green("\n        ****************************************")
						else:
							h.write("test for "+lpurple(line)+"     \t"+red('FAILED')+"\n")		
							l.write("<p>test for <font color=\"purple\">"+line+"</font> &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; <font color=\"red\">FAILED</font></p>")		
							print red("\n        **************************************************")
							print red("        ** "+line+" is NOT valid. Please debugging.. **")
							print red("\n        **************************************************")
					g.close()
		f.close()
		h.write("\n")
		l.write("<br>")
		h.close()

		if not os.path.exists('current_run'):
			OSinfo('mkdir current_run')

		if not os.path.exists('current_run/'+configName):
			OSinfo('mkdir current_run/'+configName)

		OSinfo('mv -f param.def current_run/'+configName)
		OSinfo('mv -f all_param.def current_run/'+configName)
		OSinfo('mv -f user_param.py current_run/'+configName)
		OSinfo('mv -f iodef.xml current_run/'+configName)
		OSinfo('rm -f current_run/'+configName+'/context_atm.xml')
		OSinfo('cp -n context_atm.xml current_run/'+configName)
		OSinfo('cp -f context_grid_dynamico.xml current_run/'+configName)
		OSinfo('cp -f dynamico_grid.nc current_run/'+configName)
		OSinfo('mv -f xios_*.out current_run/'+configName)
		OSinfo('mv -f xios_*.err current_run/'+configName)




if __name__== "__main__":
  main()
