import os
import sys
import subprocess

def main():


	dirpath = os.getcwd()
	my_list = os.listdir(dirpath)

	test_list=[]
	for folder in my_list:
		if folder.startswith("test_"):
			test_list.append(folder)
	FNULL = open(os.devnull, 'w')
	retcode = subprocess.call(['bash', 'setup.sh'], stdout=FNULL, stderr=subprocess.STDOUT)
	if retcode!=0:	
		print("setup.sh failed")
		print >> sys.stderr, retcode
		sys.exit()
	

	f=open("CMakeLists.txt", "w")

	f.write("####################################\n")
	f.write("# file generated by user_config.py #\n")
	f.write("#      DO NOT modify               #\n")
	f.write("####################################\n\n")
	
	f.write("cmake_minimum_required(VERSION 2.8.12.2)\n\n")
	f.write("project(generic_testcase)\n\n")
	f.write("enable_testing()\n\n")

	for x in range(len(test_list)):
		f.write("add_subdirectory(" + test_list[x]+ ")\n")

	f.write("\n")
	f.write("add_custom_target(\"report\")\n\n")
	f.write("add_custom_command(TARGET \"report\" \n")
	f.write("                   POST_BUILD\n")
	f.write("                   COMMAND rm -f report.txt\n")
	f.write("                   COMMAND rm -f report.html\n")

	for folder in test_list:
		f.write("                   COMMAND cat "+folder+"/report.txt >> report.txt\n")
		f.write("                   COMMAND cat "+folder+"/report.html >> report.html\n")
	f.write("                   )\n\n")
	f.close
	
	print >> sys.stderr, 0
	sys.exit()

if __name__== "__main__":
  main()
